<?php

// ####################### SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### DEFINE IMPORTANT CONSTANTS #######################
define('NO_REGISTER_GLOBALS', 1);
define('THIS_SCRIPT', 'test'); // change this depending on your filename

// ################### PRE-CACHE TEMPLATES AND DATA ######################
// get special phrase groups
$phrasegroups = array(

);

// get special data templates from the datastore
$specialtemplates = array(
    
);

// pre-cache templates used by all actions
$globaltemplates = array(
    'TEST',
);

// pre-cache templates used by specific actions
$actiontemplates = array(
);

// ######################### REQUIRE BACK-END ############################
require_once('./global.php');
if (!can_administer('canadminstyles')){
	print_cp_no_permission();
}

// #######################################################################
// ######################## START MAIN SCRIPT ############################
// #######################################################################
$navbits = array();
$navbits[$parent] = 'Test Page';

print_cp_header();
$terms = TABLE_PREFIX .'seoqueries_terms';
$terms_data = TABLE_PREFIX .'seoqueries_data';
$terms_stats = TABLE_PREFIX .'seoqueries_terms_stats';

//search form
if ($_REQUEST['do'] == 'search' || $_REQUEST['do'] == 'searching'){
	$key = '';
	$start = '';
	$end = '';
	if ( $_REQUEST['do'] == 'searching'){
		$vbulletin->input->clean_array_gpc('p', array(
			'start_date'	=> TYPE_STR,
			'end_date'		=> TYPE_STR,
			'keyword'		=> TYPE_STR,
		));
		$key = $vbulletin->GPC['keyword'];
		$start = $vbulletin->GPC['start_date'];
		$end = $vbulletin->GPC['end_date'];
	}
	//print_table_start();
	print_form_header('seofq_admin', 'searching');
	print_table_header("   ", 2, false, '', 'center');
	
	
	print_input_row(' ', 'keyword', $key );
	print_description_row('  : YYYY-MM-DD', 0, 2, '', 'right');
	print_input_row(' ', 'start_date', $start );
	print_input_row(' ', 'end_date', $end );
	print_submit_row('', ' ', 2);
	
	print_table_footer(2, '', '', 0);
	
	//pagination
	$limit = '';
	$pages_link = '';
	$per_page = 30;
	$page = 1;
	$q = "
		SELECT
			COUNT(stid) num
		FROM
			".$terms."
	";
	$count = $db->query_read( $q );
	$count = $db->fetch_array($count);
	if( $count['num']>$per_page ){
		$pages = ceil( $count['num'] / $per_page);
		$limit = ' LIMIT '.$per_page;
		//echo '<a href="?do=statistic&page=2">2</a>';
	}
	if( isset($_REQUEST['page']) ){
		$page = $_REQUEST['page'];
		$reques_page = $_REQUEST['page']-1;
		$limit = ' LIMIT '.($reques_page*$per_page).', '.$per_page.' ';
	}
}
//print all keywords
if ($_REQUEST['do'] == 'search'){
	
	print_table_start();
	print_table_header(" ", 3, false, '', 'center');
	print_cells_row(array(' ',' ',' '),1,'',3);
	$sql = "SELECT * FROM $terms WHERE term_value LIKE '%$keyword%' ORDER BY term_value ASC ".$limit;
	$terms = $db->query_read( $sql );
	while ($term = $db->fetch_array($terms)){
		$ban = $term['ban']==0 ? '<a href="?do=ban&term='.$term['stid'].'">ban</a>' : '<a href="?do=unban&term='.$term['stid'].'">unban</a>' ;
		print_cells_row( array( '<a href="?do=searching&keyword='.$term['term_value'].'">'.$term['term_value'].'</a>',$ban ,'<a href="?do=delete&term='.$term['stid'].'">delete</a>' ), false, '', 3 );
	}
	//print pagination
	if( isset($pages) ){
		for($i=1;$i<($pages+1);$i++){
			$pages_link .= $i==$page ? '&nbsp;'.$i.'&nbsp;' : '&nbsp;<a href="?do=search&page='.$i.'">'.$i.'</a>&nbsp;';
		}
		print_description_row( $pages_link,false,3,'','right');
	}
	print_table_footer(2, '', '', 0);
}
//search script
if ($_REQUEST['do'] == 'searching'){
	/*
	$vbulletin->input->clean_array_gpc('p', array(
		'start_date'	=> TYPE_STR,
		'end_date'		=> TYPE_STR,
		'keyword'		=> TYPE_STR,
	));
	$keyword = $vbulletin->GPC['keyword'];
	$start_date = $vbulletin->GPC['start_date'];
	$end_date = $vbulletin->GPC['end_date'];
	*/
	$keyword = $_REQUEST['keyword'];
	$start_date = $_REQUEST['start_date'];
	$end_date = $_REQUEST['end_date'];
	
	print_table_start();
	print_table_header("Keyword", 3, false, '', 'center');
	
	$sql = "SELECT * FROM $terms WHERE term_value ='$keyword'";
	$temp = $db->query_read( $sql );
	$row = $db->fetch_array( $temp );
	if (!empty($row)){
			
			//pagination
			$pagew = 1;
			$limitw = '';
			$pagesw_link = '';
			$q = "
				SELECT
					COUNT(stid) num
				FROM
					".$terms_stats."
				WHERE
					stid='".$row['stid']."'
			";
			$countw = $db->query_read( $q );
			$countw = $db->fetch_array($countw);
			if( $countw['num']>$per_page ){
				$pagesw = ceil( $countw['num'] / $per_page);
				$limitw = ' LIMIT '.$per_page;
				//echo '<a href="?do=statistic&page=2">2</a>';
			}
			if( isset($_REQUEST['pagew']) ){
				$pagew = $_REQUEST['pagew'];
				$reques_page = $_REQUEST['pagew']-1;
				$limitw = ' LIMIT '.($reques_page*$per_page).', '.$per_page.' ';
			}
		
		$sql = "SELECT * FROM ".$terms_stats." WHERE stid='".$row['stid']."'";
		if( preg_match( '/(\d{4})-(\d{2})-(\d{2})/', $vbulletin->GPC['start_date'], $match ) ){
			$sql .= ' AND date_clicked > \''.$match[1].'-'.$match[2].'-'.$match[3].' 00:00:00\' ';
		}
		if( preg_match('/(\d{4})-(\d{2})-(\d{2})/', $vbulletin->GPC['end_date'], $match ) ){
			$sql .= ' AND date_clicked < \''.$match[1].'-'.$match[2].'-'.$match[3].' 00:00:00\' ';
		}
		$sql .=" ORDER BY date_clicked DESC";
		$sql .= $limitw;
		$s_terms = $db->query_read( $sql );
		$ban = $row['ban']==0 ? '<a href="?do=ban&term='.$row['stid'].'">ban</a>' : '<a href="?do=unban&term='.$row['stid'].'">unban</a>' ;
		print_cells_row( array( $row['term_value'],$ban ,'<a href="?do=delete&term='.$row['stid'].'">delete</a>' ), 0, '', 3 );
		print_cells_row( array( 'Date','', 'Position on Google' ), 1, '', 3 );
		while ($s_term = $db->fetch_array($s_terms)){
			print_cells_row( array( $s_term['date_clicked'],'', $s_term['position'] ), false, '', 3 );
		}
		//print pagination
		if( isset($pagesw) ){
			for($i=1;$i<($pagesw+1);$i++){
				$pagesw_link .= $i==$pagew ? '&nbsp;'.$i.'&nbsp;' : '&nbsp;<a href="?do=searching&keyword='.$keyword.'&start_date='.$start_date.'&end_date='.$end_date.'&pagew='.$i.'">'.$i.'</a>&nbsp;';
			}
			print_description_row( $pagesw_link,false,3,'','right');
		}
	}else{//print all keywords
		print_cells_row(array('keyword','ban keyword','delete keyword'),1,'',3);
		$sql = "SELECT * FROM $terms WHERE term_value LIKE '%$keyword%' ORDER BY term_value ASC ".$limit;
		$terms = $db->query_read( $sql );
		while ($term = $db->fetch_array($terms)){
			$ban = $term['ban']==0 ? '<a href="?do=ban&term='.$term['stid'].'">ban</a>' : '<a href="?do=unban&term='.$term['stid'].'">unban</a>' ;
			print_cells_row( array( '<a href="?do=searching&keyword='.$term['term_value'].'">'.$term['term_value'].'</a>',$ban ,'<a href="?do=delete&term='.$term['stid'].'">delete</a>' ), false, '', 3 );
		}
		//print pagination
		if( isset($pages) ){
			for($i=1;$i<($pages+1);$i++){
				$pages_link .= $i==$page ? '&nbsp;'.$i.'&nbsp;' : '&nbsp;<a href="?do=search&page='.$i.'">'.$i.'</a>&nbsp;';
			}
			print_description_row( $pages_link,false,3,'','right');
		}
	}
	print_table_footer(2, '', '', 0);
}
if ($_REQUEST['do'] == 'delete'){
	$stid = (int)$_REQUEST['term'];
	if($stid<0) return;
	
	$sql = 'SELECT * FROM '.$terms.' WHERE stid='.$stid;
	$temp = $db->query_read( $sql );
	$row = $db->fetch_array( $temp );
	
	$q = 'DELETE FROM '.$terms.' WHERE stid='.$stid;
	$db->query($q);
	$q = 'DELETE FROM '.$terms_data.' WHERE stid='.$stid;
	$db->query($q);
	$q = 'DELETE FROM '.$terms_stats.' WHERE stid='.$stid;
	$db->query($q);
	print_cp_message(' <b>'.$row['term_value'].'</b>  ');
}
if ($_REQUEST['do'] == 'ban'){
	$stid = (int)$_REQUEST['term'];
	if($stid<0) return;
	
	$sql = 'SELECT * FROM '.$terms.' WHERE stid='.$stid;
	$temp = $db->query_read( $sql );
	$row = $db->fetch_array( $temp );
	
	$q = 'UPDATE '.$terms.' SET `ban`=1 WHERE stid='.$stid;
	$db->query($q);
	print_cp_message(' <b>'.$row['term_value'].'</b>  ');
}
if ($_REQUEST['do'] == 'unban'){
	$stid = (int)$_REQUEST['term'];
	if($stid<0) return;
	
	$sql = 'SELECT * FROM '.$terms.' WHERE stid='.$stid;
	$temp = $db->query_read( $sql );
	$row = $db->fetch_array( $temp );
	
	$q = 'UPDATE '.$terms.' SET `ban`=0 WHERE stid='.$stid;
	$db->query($q);
	print_cp_message(' <b>'.$row['term_value'].'</b>    ');
}

if($_REQUEST['do']=='statistic_home' || $_REQUEST['do']=='statistic_forum' || $_REQUEST['do']=='statistic_thread'){
	$per_page = isset($vbulletin->options['seofq_stat_num']) && (int)$vbulletin->options['seofq_stat_num']>0 ? $vbulletin->options['seofq_stat_num'] : 25;
	$page = 1;
	$pages_link = '';
	
	//sorting
	$order = ' DESC, ';
	$main_link = '?do='.$_REQUEST['do'];
	$title_mod = '';
	$title_mod_fo = '';
	$title_mod_da = '';
	$link_mod = 'desc';
	$link_mod_c = 'desc';
	if( isset($_REQUEST['direction']) && $_REQUEST['direction']=='desc' ){
		$order = ' DESC, ';
		$title_mod = ' &darr; ';
		$link_mod = 'desc';
		$link_mod_c = 'asc';
	}elseif(isset($_REQUEST['direction']) && $_REQUEST['direction']=='asc'){
		$order = ' ASC, ';
		$title_mod = ' &uarr; ';
		$link_mod = 'asc';
		$link_mod_c = 'desc';
	}
	$filter = ' sd.founded ';
	if( isset($_REQUEST['filter']) && $_REQUEST['filter']=='founded' ){
		$main_link .= '&filter=founded&direction='.$link_mod;
		$filter = ' sd.founded ';
		$title_mod_fo = $title_mod;
	}elseif( isset($_REQUEST['filter']) && $_REQUEST['filter']=='date' ){
		$main_link .= '&filter=date&direction='.$link_mod;
		$filter = ' max_d ';
		$title_mod_da = $title_mod;
	}
	
	//pagination
	switch($_REQUEST['do']){
		case 'statistic_home':
			$page_type = 'index';
		break;
		case 'statistic_forum':
			$page_type = 'forumdisplay';
		break;
		case 'statistic_thread':
			$page_type = 'showthread';
		break;
	}
	$limit = '';
	$q = "
		SELECT
			COUNT(stid) as num
		FROM
			".$terms_data." sd
		WHERE
			sd.page_type='".$page_type."'
		";
	$count = $db->query_read( $q );
	$count = $db->fetch_array($count);
	
	if( $count[num]>$per_page ){
		$pages = ceil( $count['num'] / $per_page);
		$limit = ' LIMIT '.$per_page;
		//echo '<a href="?do=statistic&page=2">2</a>';
	}
	if( isset($_REQUEST['page']) ){
		$page = $_REQUEST['page'];
		$reques_page = $_REQUEST['page']-1;
		$limit = ' LIMIT '.($reques_page*$per_page).', '.$per_page.' ';
	}
}
if ($_REQUEST['do'] == 'statistic_home'){
	//home page
	print_table_start();
	print_table_header("  ", 4, false, '', 'center');
	print_cells_row( array(
						   ' ',
						   '<a href="?do=statistic_home&filter=founded&direction='.$link_mod_c.'">  </a>'.$title_mod_fo,
						   '  ',
						   '<a href="?do=statistic_home&filter=date&direction='.$link_mod_c.'">  </a>'.$title_mod_da
						),
					1, '', 3
	);
	//select terms
	$q = "
		SELECT
			MAX(st.date_clicked) max_d, sd.founded, t.term_value, st.position
		
		FROM ".$terms_stats." st
		
		LEFT JOIN ".$terms_data." sd 
			ON st.stid = sd.stid 
			AND st.page_type = sd.page_type
		
		LEFT JOIN ".$terms." t
			ON sd.stid = t.stid
		
		WHERE
			st.page_type = 'index'
			AND
			t.ban = 0
		
		GROUP BY 
			st.stid
		
		ORDER BY
			#max_d DESC,
			#sd.founded DESC,
			".$filter." ".$order."
			t.term_value ASC
			
		".$limit."
	";
	$terms_res = $db->query_read( $q );
	while ($term = $db->fetch_array($terms_res)){
		print_cells_row(
					array(
						'<a href="?do=searching&keyword='.$term['term_value'].'">'.$term['term_value'].'</a>',
						$term['founded'],
						$term['position']==0?'-':$term['position'],
						$term['max_d']
					),
					false, '', 3
		);
	}
	//pagination print
	if( isset($pages) ){
		for($i=1;$i<($pages+1);$i++){
			$pages_link .= $i==$page ? '&nbsp;'.$i.'&nbsp;' : '&nbsp;<a href="'.$main_link.'&page='.$i.'">'.$i.'</a>&nbsp;';
		}
		print_description_row( $pages_link,false,4,'','right');
	}
	print_table_footer(4, '', '', 0);
}
if ($_REQUEST['do'] == 'statistic_forum'){
	//forumdisplay
	print_table_start();
	print_table_header("  ", 4, false, '', 'center');
	
	print_cells_row( array(
					   ' ',
					   '<a href="?do=statistic_forum&filter=founded&direction='.$link_mod_c.'">  </a>'.$title_mod_fo,
					   '  ',
					   '<a href="?do=statistic_forum&filter=date&direction='.$link_mod_c.'">  </a>'.$title_mod_da
					),
				1, '', 3
	);
	
	//select terms
	$q = "
		SELECT
			MAX(st.date_clicked) max_d, st.page_id, st.stid, sd.founded, t.term_value, st.position
		
		FROM
			".$terms_stats." st
		
		LEFT JOIN ".$terms_data." sd 
			ON st.stid = sd.stid 
			AND st.page_type = sd.page_type
			AND st.page_id = sd.page_id
		
		LEFT JOIN ".$terms." t
			ON sd.stid = t.stid
		
		WHERE
			st.page_type = 'forumdisplay'
			AND
			t.ban = 0
		
		GROUP BY
			st.page_id,
			st.stid
			
		ORDER BY
			#max_d DESC,
			#sd.founded DESC,
			st.page_id DESC,
			".$filter." ".$order."
			t.term_value ASC
			
		".$limit."
	";
	$terms_res = $db->query_read( $q );
	$this_id = null;
	while ($term = $db->fetch_array($terms_res)){
		if($this_id != $term['page_id']){
			$this_id = $term['page_id'];
			print_description_row( 'forum #'.$this_id,false,4,'','left');
		}
		print_cells_row(
					array(
						'<a href="?do=searching&keyword='.$term['term_value'].'">'.$term['term_value'].'</a>',
						$term['founded'],
						$term['position']==0?'-':$term['position'],
						$term['max_d']
					),
					false, '', 3
		);
	}
	//pagination print
		if( isset($pages) ){
			for($i=1;$i<($pages+1);$i++){
				$pages_link .= $i==$page ? '&nbsp;'.$i.'&nbsp;' : '&nbsp;<a href="'.$main_link.'&page='.$i.'">'.$i.'</a>&nbsp;';
			}
			print_description_row( $pages_link,false,4,'','right');
		}
	print_table_footer(4, '', '', 0);
}
if ($_REQUEST['do'] == 'statistic_thread'){
	//showthread
	print_table_start();
	print_table_header("  ", 4, false, '', 'center');
	print_cells_row( array(
					   ' ',
					   '<a href="?do=statistic_thread&filter=founded&direction='.$link_mod_c.'">  </a>'.$title_mod_fo,
					   '  ',
					   '<a href="?do=statistic_thread&filter=date&direction='.$link_mod_c.'">  </a>'.$title_mod_da
					),
				1, '', 3
	);
	
	//select terms
	$q = "
		SELECT
			MAX(st.date_clicked) max_d, st.page_id, st.stid, sd.founded, t.term_value, st.position
		
		FROM
			".$terms_stats." st
		
		LEFT JOIN ".$terms_data." sd 
			ON st.stid = sd.stid 
			AND st.page_type = sd.page_type
			AND st.page_id = sd.page_id
		
		LEFT JOIN ".$terms." t
			ON sd.stid = t.stid
		
		WHERE
			st.page_type = 'showthread'
			AND
			t.ban = 0
		
		GROUP BY
			st.page_id,
			st.stid
		ORDER BY
			#max_d DESC,
			#sd.founded DESC,
			st.page_id DESC,
			".$filter." ".$order."
			t.term_value ASC
			
		".$limit."
	";
	$terms_res = $db->query_read( $q );
	$this_id = null;
	while ($term = $db->fetch_array($terms_res)){
		if($this_id != $term['page_id']){
			$this_id = $term['page_id'];
			print_description_row( 'thread #'.$this_id,false,4,'','left');
		}
		print_cells_row(
					array(
						'<a href="?do=searching&keyword='.$term['term_value'].'">'.$term['term_value'].'</a>',
						$term['founded'],
						$term['position']==0?'-':$term['position'],
						$term['max_d']
					),
					false, '', 3
		);
	}
	//pagination print
		if( isset($pages) ){
			for($i=1;$i<($pages+1);$i++){
				$pages_link .= $i==$page ? '&nbsp;'.$i.'&nbsp;' : '&nbsp;<a href="'.$main_link.'&page='.$i.'">'.$i.'</a>&nbsp;';
			}
			print_description_row( $pages_link,false,4,'','right');
		}
	print_table_footer(4, '', '', 0);
}
if ($_REQUEST['do'] == 'banlist'){
	
	//pagination
	$per_page = isset($vbulletin->options['seofq_stat_num']) && (int)$vbulletin->options['seofq_stat_num']>0 ? $vbulletin->options['seofq_stat_num'] : 25;
	$limit = '';
	$q = "
		SELECT
			COUNT(stid) as num
		FROM
			".$terms." sd
		WHERE
			ban = 1
		";
	$count = $db->query_read( $q );
	$count = $db->fetch_array($count);
	if( $count[num]>$per_page ){
		$pages = ceil( $count['num'] / $per_page);
		$limit = ' LIMIT '.$per_page;
	}
	if( isset($_REQUEST['page']) ){
		$page = $_REQUEST['page'];
		$reques_page = $_REQUEST['page']-1;
		$limit = ' LIMIT '.($reques_page*$per_page).', '.$per_page.' ';
	}
	//*pagination
	
	print_table_start();
	print_table_header(" ", 2, false, '', 'center');
	print_cells_row( array(
					   ' ',
					   ' ',
					),
				1, '', 3
	);
	
	$q = '
		SELECT
			*
		FROM
			'.$terms.'
		WHERE
			ban = 1
		ORDER BY
			term_value ASC
		'.$limit.'
	';
	$terms_res = $db->query_read( $q );
	while ($term = $db->fetch_array($terms_res)){
		print_cells_row(
					array(
						'<a href="?do=searching&keyword='.$term['term_value'].'">'.$term['term_value'].'</a>',
						'<a href="?do=unban&term='.$term['stid'].'">unban</a>',
					),
					false, '', 3
		);
	}
	//pagination print
	if( isset($pages) ){
		for($i=1;$i<($pages+1);$i++){
			$pages_link .= $i==$page ? '&nbsp;'.$i.'&nbsp;' : '&nbsp;<a href="?do=banlist&page='.$i.'">'.$i.'</a>&nbsp;';
		}
		print_description_row( $pages_link,false,2,'','right');
	}
	
	print_table_footer(2, '', '', 0);
}

print_cp_footer();
?>